/* A simple "hello world" like program using sssd */

#include <stdlib.h>

#ifdef __ELATE__
#include <amiga/sssd.h>
#else
#include <sssd.h>     /* libsssd defines */
#endif


/*  uncomment if you want debugging info from loadSimpleWave */
/*#define _DEBUG_*/
#include "loadSimpleWave.h"  /* routine to load simple Wav file */

int main(int argc, char **argv)
{

    /* libsssd handle */
    struct sssdaudio *ga;

    /* sample references */
    int hello_id=0;
    
    /* play references (not needed) */
    int hello_play;
   
    /* wave file info */
    waveFile *waveData;
       
    /* Initialize audio */
    ga=sssd_initAudio(
    		 1,		/* Channels: 1=mono, 2=stereo */
    		 22050,		/* Frequency */
		 8,		/* bits per sample (8|16) */
		 1,		/* Maximum simul voices */
		 1,		/* Maximum samples */
		 0,              /* Size of audio hardware bufffer 0=let system decide */
		 DEFAULT_NUMBUFFERS, /* Number of audio hardware bufffers */
		 0);		/* Flags */

    /* open soundcard device */
    if( sssd_isError(sssd_startAudio( ga, DEFAULT_DEVICE)) ) exit(-1);

    /* load simple Wav file */
    waveData=loadSimpleWave("hello.wav");
    if(waveData==NULL) { 
       printf("Could not load hello.wav\n");
       exit(-1);
    }
    
    /* pre-cache samples ... keeping id's */
    /* simpleWave2copySample is a macro that fills in args to sssd_copySample */
    /* when used with loadSimpleWave() */
    hello_id   = simpleWave2copySample( ga, waveData, COPY_DONT_RESAMPLE);
    
    /* As soon as sample is copy cached, we can delete the local copy */
    free(waveData);
    
    /* make sure there wasn't an error copying the sample */
    if(sssd_isError(hello_id)) {
       printf("Error copying sample to sssd (%d)\n",hello_id);
       exit(-2);
    }

    /* play sample */
    hello_play=sssd_playSample( ga, hello_id, 1, 256, 0 );
    
    /* Wait until the sample has finished playing */
    sssd_blockUntilComplete(ga, hello_play);

    /* Shut audio down */
    sssd_stopAudio( ga ); 
    sssd_freeAudio( ga );
    
    return( 0 );
}
